#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

typedef struct cvor* PCVOR;

typedef struct cvor {
	int podatak;
	PCVOR sledeci;
} CVOR;

void ubaciNaPocetak(PCVOR *glava, int podatak);
void ubaciNaKraj(PCVOR *glava, int podatak);
void prikazListe(PCVOR glava);
int izbaciSaPocetka(PCVOR *glava);

int main(void) {
	/*
	int *p = NULL;
	p = (int)malloc(sizeof(int));

	*p = 100;

	printf("&p=%p, p=%p, *p=%d\n", &p, p, *p);

	free(p);
	p = NULL;

	printf("&p=%p, p=%p, *p=%d\n", &p, p, *p);

	p = (int)malloc(sizeof(int));
	*p = 200;
	*/

	PCVOR glava=NULL;

	ubaciNaPocetak(&glava, 5);
	ubaciNaPocetak(&glava, 10);
	ubaciNaPocetak(&glava, 15);
	ubaciNaPocetak(&glava, 20);

	/*
	ubaciNaKraj(&glava,5);
	ubaciNaKraj(&glava, 10);
	ubaciNaKraj(&glava, 15);
	ubaciNaKraj(&glava, 20);
	*/
	prikazListe(glava);

	printf("Izbacen je %d\n",izbaciSaPocetka(&glava));
	printf("Izbacen je %d\n", izbaciSaPocetka(&glava));
	printf("Izbacen je %d\n", izbaciSaPocetka(&glava));


	prikazListe(glava);


	system("pause");
	return 0;
}

void ubaciNaPocetak(PCVOR *glava, int podatak) {
	PCVOR novi = (PCVOR)malloc(sizeof(CVOR));

	novi->podatak = podatak;
	novi->sledeci = *glava;
	*glava = novi;
}

void ubaciNaKraj(PCVOR *glava, int podatak) {
	PCVOR tek;
	
	PCVOR novi = (PCVOR)malloc(sizeof(CVOR));

	novi->podatak = podatak;
	novi->sledeci = NULL;

	if (*glava == NULL) {
		*glava = novi;
	}
	else {
		tek = *glava;
		while (tek->sledeci != NULL) {
			tek = tek->sledeci;
		}
		tek->sledeci = novi;
	}

	

}

void prikazListe(PCVOR glava) {
	PCVOR tek;
	tek = glava;
	printf("Elementi liste su:\n");
	while (tek != NULL) {
		printf("%d\t", tek->podatak);
		tek = tek->sledeci;
	}
	printf("\n");
}

int izbaciSaPocetka(PCVOR *glava) {
	int izbacen = -999;
	PCVOR tek;
	if ((*glava) == NULL) {
		printf("Lista je prazna!\n");
	}
	else {
		tek = *glava;
		izbacen = (*glava)->podatak;
		*glava = (*glava)->sledeci;
		free(tek);
		tek = NULL;
	}

	return izbacen;
}
